/*#######################################################################################
AVR Programm to controll the M64282 CMOS image sensor

Copyright (C) 2005 Ulrich Radig

Bei Fragen und Verbesserungen wendet euch per EMail an

mail@ulrichradig.de

oder im Forum meiner Web Page : www.ulrichradig.de


Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
GNU General Public License, wie von der Free Software Foundation verffentlicht, 
weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
(nach Ihrer Option) jeder spteren Version. 

Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
Programm erhalten haben. 
Falls nicht, schreiben Sie an die Free Software Foundation, 
Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
#######################################################################################*/

#ifndef _cam_h_
	#define _cam_h_
		
extern void Init_Cam (void);
extern void Cam_Data_Load_Seq (unsigned char, unsigned char);
	
#define CAM_PORT	PORTD	//Serial-Bus is connect to Portd
#define CAM_PIN		PIND	
#define CAM_DDR		DDRD	//Data Direction Register

#define CAM_START	2	//Pin 2
#define CAM_SIN		3	//Pin 3
#define CAM_LOAD	4	//Pin 4
#define CAM_RESET	5	//Pin 5
#define CAM_CLOCK	6	//Pin 6
#define CAM_READ	7	//Pin 7

#define LOW 		0
#define BIT8		0x80


#define CAM_START_HIGH() CAM_PORT|=(1<<CAM_START); 	//START PIN High
#define CAM_START_LOW() CAM_PORT&=~(1<<CAM_START); 	//START PIN Low

#define CAM_SIN_HIGH() CAM_PORT|=(1<<CAM_SIN); 		//SIN PIN High
#define CAM_SIN_LOW() CAM_PORT&=~(1<<CAM_SIN); 		//SIN PIN Low

#define CAM_LOAD_HIGH() CAM_PORT|=(1<<CAM_LOAD); 	//LOAD PIN High
#define CAM_LOAD_LOW() CAM_PORT&=~(1<<CAM_LOAD);	//LOAD PIN Low

#define CAM_RESET_HIGH() CAM_PORT|=(1<<CAM_RESET);	//RESET PIN High
#define CAM_RESET_LOW() CAM_PORT&=~(1<<CAM_RESET);	//RESET PIN Low

#define CAM_CLOCK_HIGH() CAM_PORT|=(1<<CAM_CLOCK);	//CLOCK PIN High
#define CAM_CLOCK_LOW() CAM_PORT&=~(1<<CAM_CLOCK);	//CLOCK PIN Low

#define nop()  __asm__ __volatile__ ("nop" ::)		//No Operation

struct Camera_Register {
		unsigned char O		:6	;
		unsigned char Z		:2	;
		unsigned char G		:5	;
		unsigned char VH		:2	;
		unsigned char N		:1	;
		unsigned char C1		:8	;
		unsigned char C0		:8	;
		unsigned char P		:8	;
		unsigned char M		:8	;
		unsigned char X		:8	;
		unsigned char V		:3	;
		unsigned char I		:1	;
		unsigned char E		:4	;
		};
		
#endif //_cam_h_






